﻿note
	description: "Object that checks whether the properties verified within set theory hold for an implementation of {STS_ELEMENT}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

class
	ELEMENT_PROPERTIES

inherit
	STS_ELEMENT

feature -- Properties (Membership)

	is_in_ok (a: STS_ELEMENT; s: STS_SET [STS_ELEMENT, STS_EQUALITY [STS_ELEMENT]]): BOOLEAN
			-- Do the properties verified within set theory hold for {STS_ELEMENT}.is_in?
		do
			check
				require_non_emptiness: a ∈ s implies not s.is_empty
			then
				Result := True
			end
		end

note
	copyright: "Copyright (c) 2012-2023, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: ""
end
